const util = require('@/utils/util.js').default;
// import requestConfig from '@/static/lib/requestConfig';
export default {
	data() {
		return {
		}
	},
	mounted() {
		console.warn("---mounted---",this.pvId,this.$route.meta.keepAlive)
		if(this.pvId && !this.$route.meta.keepAlive){
			window.removeEventListener('beforeunload', this.pvCloseHandle);
			window.removeEventListener('visibilitychange', this.visibilitychange);
			window.currentPage = this;
			if(window.webglCom && window.webglCom.starRender && typeof(window.webglCom.starRender)==='function'){
				window.webglCom.starRender()
			}
			let param = {
				type: 'PV',
				pvId: this.pvId,
				locusBehaviorName: this.locusBehaviorName,
				pvCurPageName: this.pvCurPageName,
			};
			util.trackRequest(param);//发送统一PV埋点
			window.addEventListener('beforeunload', this.pvCloseHandle);
			window.addEventListener('visibilitychange', this.visibilitychange);
			if(window.webglCom){
				if(this.$route.name=="webgl_rxdz" || this.$route.name=="webgl_rxdz_test"){
					console.warn("***webgl_rxdz_test***",this.canvasHeight)
					// window.webglCom.setHeight(this.canvasHeight);
					// window.webglCom.cameraInit();
					window.webglCom.styleType = this.styleType;
					// webglCom.moveMeshCenterIm(this.curHouseObj);
				}
			}
			if(this.$route.name=="webgl_rxdz" || this.$route.name=="webgl_rxdz_roam" || this.$route.name=="webgl_rxdz_look"
			 || this.$route.name=="webgl_rxdz_test" || this.$route.name=="webgl_rxdz_test_roam" || this.$route.name=="webgl_rxdz_test_look"){//去往其他页面
				if(window.webglCom){
					window.webglCom.showWebgl = true;//显示webgl
					mapVue.$forceUpdate()
				}
			}else{
				if(window.webglCom){
					window.webglCom.showWebgl = false;//隐藏webgl
					mapVue.$forceUpdate()
				}
			}
		}
	},
	//页面销毁时，注销监听程序|返回上一页，去往下一页等
	destroyed(){
		window.removeEventListener('beforeunload', this.pvCloseHandle);
		window.removeEventListener('visibilitychange', this.visibilitychange);
	},
	// beforeDestroy() {
	// 	console.warn("---beforeDestroy---")
	// 	this.pvCloseHandle()
	// },
	// /**
	//  * 生命周期函数--监听页面隐藏
	//  */
	// onHide: function() {
	// 	console.warn("---onhide---")
	// 	this.pvCloseHandle()
	// },
	// beforeUpdate() {
	// 	console.warn("beforeUpdate");
	// 	// 移除visibilitychange事件监听器
	// 	window.removeEventListener('visibilitychange', this.visibilitychange);
	// },
	beforeRouteLeave(to, from, next) {
		console.warn("router:beforeRouteLeave:",from.name);
		// 在离开当前路由前执行的方法
		// 例如保存表单数据、清理定时器等操作
		this.pvCloseHandle();
		if(window.webglCom){
			// window.webglCom.stopRender();
			if(from.name=="webgl_rxdz" || from.name=="webgl_rxdz_test"){//从俯瞰模式页面退出
				window.webglCom.saveState();//保存当前的控制器状态
			}
			if(from.name=="webgl_rxdz_roam" || from.name=="webgl_rxdz_test_roam"){//从漫游模式退出
				window.webglCom.spaceLeave();//执行离开的方法，清空限制空间的处理
			}
		}
		window.removeEventListener('beforeunload', this.pvCloseHandle);//注销监听刷新事件
		window.removeEventListener('visibilitychange', this.visibilitychange);
		next();
	},
	beforeRouteEnter(to, from, next) {
		console.warn("router:beforeRouteEnter:",to.name,to);
		if(window.webglCom){
			if(to.name=="webgl_rxdz_roam" || to.name=="webgl_rxdz_test_roam"){//进入漫游模式
				window.webglCom.spaceEnter();//保存当前的控制器状态
			}
			if(to.name=="webgl_rxdz" && from.name=="webgl_rxdz_roam"){//从漫游模式返回俯瞰模式
				// window.webglCom.reset()
			}
			if(to.name=="webgl_rxdz_test" && from.name=="webgl_rxdz_test_roam"){//从漫游模式返回俯瞰模式
				// window.webglCom.reset()
			}
			if(to.name=="webgl_rxdz_roam" && from.name=="webgl_rxdz_customize"){//从作品页返回空间详情页面
				window.webglCom.spaceEnter()
			}
		}
		next();
	},
	activated(options){
		console.warn("activated:",this.pvId,options); 
		if(this.pvId && this.$route.meta.keepAlive){
			window.removeEventListener('beforeunload', this.pvCloseHandle);
			window.removeEventListener('visibilitychange', this.visibilitychange);
			window.currentPage = this;
			if(window.webglCom && window.webglCom.starRender && typeof(window.webglCom.starRender)==='function'){
				window.webglCom.starRender()
			}
			let param = {
				type: 'PV',
				pvId: this.pvId,
				locusBehaviorName: this.locusBehaviorName,
				pvCurPageName: this.pvCurPageName,
			};
			util.trackRequest(param);//发送统一PV埋点
			window.addEventListener('beforeunload', this.pvCloseHandle);
			window.addEventListener('visibilitychange', this.visibilitychange);
			if(window.webglCom){
				if(this.$route.name=="webgl_rxdz" || this.$route.name=="webgl_rxdz_test"){
					console.warn("***webgl_rxdz***",this.canvasHeight)
					window.webglCom.setHeight(this.canvasHeight);
					window.webglCom.cameraInit();
					window.webglCom.styleType = this.styleType;
					webglCom.moveMeshCenterIm(this.curHouseObj);
				}
				if(this.$route.name=="webgl_rxdz" || this.$route.name=="webgl_rxdz_roam" || this.$route.name=="webgl_rxdz_look"
				 || this.$route.name=="webgl_rxdz_test" || this.$route.name=="webgl_rxdz_test_roam" || this.$route.name=="webgl_rxdz_test_look"){//去往其他页面
					if(window.webglCom){
						window.webglCom.showWebgl = true;//显示webgl
						mapVue.$forceUpdate()
					}
				}else{
					if(window.webglCom){
						window.webglCom.showWebgl = false;//隐藏webgl
						mapVue.$forceUpdate()
					}
				}
			}
		}
	},
	methods: {
		visibilitychange(){
			console.warn("visibilitychange");
			if (document.visibilityState !== 'visible') { // 离开页面
				if(window.webglCom && window.webglCom.stopRender && typeof(window.webglCom.stopRender)==='function'){
					window.webglCom.stopRender()
				}
				this.pvCloseHandle()
			} else { // 进入页面
				if(window.webglCom && window.webglCom.starRender && typeof(window.webglCom.starRender)==='function'){
					window.webglCom.starRender()
				}
				this.pvShowHandle()
			}
		},
		pvShowHandle(){
			if(this.pvId){
				let param = {
					type: 'PV',
					pvId: this.pvId,
					locusBehaviorName: this.locusBehaviorName,
					pvCurPageName: this.pvCurPageName,
				};
				util.trackRequest(param);//发送统一PV埋点
			}
		},
		pvCloseHandle(){
			if(this.pvId){
				let param = {
					type: 'PV',
					pvId: this.pvId + '_close',
					pvCurPageName: this.pvCurPageName,
					locusBehaviorName: this.locusBehaviorName,
				};
				util.trackRequest(param);
			}
		},
	}
}
